;------------------------------------------------------------------------------
; text viewer 80x25 chars
; For more information on the IDE64 project,
; please see http://ide64.come.to
; or mail to: Josef.Soucek@ct.cz
;------------------------------------------------------------------------------

         *= $1000
         
; Externi utilita pro manager HDD
; Umoznuje prohlizeni souboru
; Neumi cist z DD SEQ soubory, musim opravit


graphics = $2000    
             

graph_lo = $dd
graph_hi = graph_lo+1


char_lo  = $df
char_hi  = char_lo+1

;----------------------
second   = $ff93
tksa     = $ff96
acptr    = $ffa5
untlk    = $ffab
unlsn    = $ffae
listen   = $ffb1
talk     = $ffb4
setlfs   = $ffba
setnam   = $ffbd
open     = $ffc0
close    = $ffc3
chkin    = $ffc6
chkout   = $ffc9
chrin    = $ffcf
chrout   = $ffd2
stop     = $ffe1
getin    = $ffe4
clall    = $ffe7
udtim    = $ffea
plot     = $fff0
;-------------------------



start    jsr get_name
         jsr setnam

         lda #1
         ldx $ba
         ldy #0
         jsr setlfs   ;soubor pro cteni

         jsr open     ;otevreni souboru pro cteni
         
       ;  jsr read_status
         clc 
         bcc file_open_ok
         lda #$01     ;zavreni souboru
         jsr close
         jsr clall    ;nastaveni standartni I/O
         rts          ;navrat do puvodni aplikace
         
file_open_ok
         jsr init80   ;prepne na 80 znakovy zobrazovac
         ldx #1
         jsr chkin    ;soubor 1 je vstup
         lda #$00
         sta $90
         sta error
print_again 
         jsr chrin
         ldx $90
         bne file_end
         jsr print_char
         lda error        ;test klavesy stop
         beq print_again  ;ne, tisk dalsich znaku
         jsr file_close   ;ano, uzavri soubor
         jsr init40       ;inituj obrazovku
         sec
         rts
         
file_end jsr file_close   ;zavri soubory

         ldy #$00
print_end lda endoftext,y  ;end of text
         beq press_runstop
         jsr print
         iny
         bne print_end
         
press_runstop
         jsr getin
         beq press_runstop
         cmp #95
         bne press_runstop
         
         jsr init40    ;prepne na 40 znakovy zobrazovac
         clc           ;navrat do puvodni aplikace, bez chyby
         rts

file_close lda #1
         jsr close
         jsr clall
         rts



;--------------------------------------------------
; routine GET FILENAME
get_name  jsr clall         ;prepnout na standartni I/O
          lda #<input_txt   ;tisk VIEW FILE
          ldy #>input_txt
          jsr $ab1e
          
          ldy #$00
rd_name   jsr chrin
          sta filename,y    ;zadani nazvu souboru
          iny
          cmp #$0d
          bne rd_name
          tya
          ldx #<filename
          ldy #>filename
          rts
          
;------------------------------------------         
; routine READ DEVICE STATUS
;------------------------------------------
read_status  lda #$00
             sta $b7    ;soubor bez jmena
             
             lda #$0f   ;soubor c.15
             ldx $ba    ;na aktualnim zarizeni
             tay
             jsr setlfs
             jsr open
             ldx #$0f
             jsr chkin  ;prepnout error kanal na vstup
             
             jsr chrin  ;cte 1. znak statusu
             asl
             asl
             asl
             asl
             sta error
             jsr chrin     ;cte 2. znak statusu
             and #%00001111
             ora error
             sta error
rdsts        jsr chrin
             cmp #$0d
             bne rdsts
             lda #$0f
             jsr close     ;zavre error kanal
             lda error
             beq no_error
             sec
             .byte $24
no_error     clc           ;otevreno bez chyby
             rts
             
             
error        .byte 0

;-------------------------------------

;Pouzita grafika . $20-$40
;barvy ........... $04-$08
;Znaky.1..0-255... $90-$98 (ctrg)


;------------------- INIT 40 Znaku -----
init40   lda #147
         jsr chrout     ;smazat obrazovku

         lda #27        ;nahodi text
         sta 53248+17
         lda #21
         sta 53248+24

      ;   lda #$01      ;sprav Kurzor
      ;   sta $cc 
         lda #$00
         sta $028a      ;vypnout opakovani klaves
         sta $c6        ;nuluje pocet klaves
         rts    
         

;------------------- INIT 80 Znaku -----
init80   jsr clrscr     ;snaze grafickou obrazovku + kurzor home

         lda #59        ;nahodi grafiku
         sta 53248+17
         lda #24
         sta 53248+24

      ;   lda #11
      ;   sta $d020       ;barva borderu

         ldy #0
         lda #%00010110  ;barva znaku
      
      
bila     sta $0400,y
         sta $0500,y
         sta $0600,y
         sta $06e8,y
         dey
         bne bila
         
         lda #$80
         sta $028a ;zapnout opakovani klaves
         rts





;---------------------------------------------------
               ;vypoc.zacatku graf.radku

grafrad  lda $d6    ;radek  (0-24)
         asl a
         tax
         lda $d3    ;sloupec (0-79)
         and #$fe
         clc
         adc obraz,x
         sta graph_lo
         lda obraz+1,x
         adc #0
         sta graph_hi

         asl graph_lo  ;x4
         rol graph_hi
         asl graph_lo  ;x8
         rol graph_hi

         lda #>graphics  ;base addr of graphics page
         clc
         adc graph_hi
         sta graph_hi
         rts


obraz    .byte $00,$00,$50,$00,$a0,$00
         .byte $f0,$00,$40,$01,$90,$01
         .byte $e0,$01,$30,$02,$80,$02
         .byte $d0,$02,$20,$03,$70,$03
         .byte $c0,$03,$10,$04,$60,$04
         .byte $b0,$04,$00,$05,$50,$05
         .byte $a0,$05,$f0,$05,$40,$06
         .byte $90,$06,$e0,$06,$30,$07
         .byte $80,$07
         






;------------------------------------------------------
delete   dec $d3       ;sloupec zpet
         bpl prjnic
         lda $d6
         beq prjnic
         dec $d6       ;radek zpet
         lda #79       ;nastavit sloupec
         sta $d3
prjnic   rts


return1  lda #0         ;kurzor na zacatek radku
         sta $d3
         jmp down_crsr  ;kurzor dolu
         
;clrscr   lda #0        ;crsr HOME
;         sta $d3
;         sta $d6
;         jmp clrscr     ;smazani obrazovky
         
zvonek   lda #11        ;ZVUK.
         sta $d020
nic      rts



;---------------------------------------
print    sty y_reg
         jsr print_char
         ldy y_reg
         rts
         
y_reg    .byte 0


print_char ldy #3      ;citac kurzoru
         sty $cd
         ldy #1
         sty $cf     ;faze kurzoru

         cmp #13     ;test znaku na CR
         beq return1
         cmp #10     ;test znaku na LF
         beq return1
         cmp #8      ;test DEL
         beq delete
         cmp #12
        ;beq clrscr
         cmp #7
        ;beq zvonek

         tax
         lda screen,x ;prepocet ASCII

         beq nic      ;zadny znak k tisku

zvedav   sta char_lo     ;vypocet zac.znaku v sade
         lda #0
         sta char_hi
         asl char_lo     ;x8
         rol char_hi
         asl char_lo
         rol char_hi
         asl char_lo
         rol char_hi

         lda char_hi
         clc
         adc #>charset  ;baseaddr of charset   
         sta char_hi

         jsr grafrad    ;nastaveni adresy v obrazovce
         lda $d3
         and #1         ;test, je-li prvnim znakem v atributu
         bne jinej
                        

;------------------------------PRVNI ZNAK
         ldy #7
cykl1    lda (graph_lo),y        ;pozici na prvnim znaku smaze
         and #$0f
         sta (graph_lo),y

         lda (char_lo),y    ;nacte znak

         and #$f0           ;2 znak odmaskovat
         ora (graph_lo),y
         sta (graph_lo),y        ;a pridat
         dey
         bpl cykl1
         jmp right_crsr 
         

;------------------------------DRUHY ZNAK

jinej    ldy #7
cykl2    lda (graph_lo),y        ;pozici pro druhy znak smazat
         and #$f0
         sta (graph_lo),y

         lda (char_lo),y    ;nacist znak

         and #$0f           ;prvni znak odmaskovat
         ora (graph_lo),y
         sta (graph_lo),y        ;a pridat
         dey
         bpl cykl2
                            

;------------------------------kurzor vpravo
right_crsr inc $d3
         lda $d3
         cmp #$50
         bne nescro         ;nejsem vpravo
         lda #0
         sta $d3

;------------------------------kurzor dolu
down_crsr inc $d6           ;dalsi radek
         lda $d6
         cmp #$19
         bne nescro         ;nejsem dole
         dec $d6            ;kurzor stale na posledni radek
         
get_key  lda $c6
         beq get_key
         lda #$00
         sta $c6
         lda $0277
         cmp #$11      ;crsr down
         beq new_line
         cmp #$88      ;page down
         beq new_page
         cmp #$03      ;runstop
         bne new_line
         sta error
         rts
         
new_line jsr fast_scroll ;dalsi radek
nescro   rts

new_page jmp clrscr    ;smaze obrazovku, kurzor home



;---------------------------------------
;Scroll grafiky pro 80 znaku
;---------------------------------------
;presunuje grafiku o radek nahoru

fast_scroll
         sei  
         ldy #0
move_all lda $2140,y
         sta $2000,y
         lda $21e0,y
         sta $20a0,y
         
         lda $2280,y
         sta $2140,y
         lda $2320,y
         sta $21e0,y
         
         lda $23c0,y
         sta $2280,y
         lda $2460,y
         sta $2320,y
         
         lda $2500,y
         sta $23c0,y
         lda $25a0,y
         sta $2460,y
                    
         lda $2640,y
         sta $2500,y
         lda $26e0,y
         sta $25a0,y
         
         lda $2780,y
         sta $2640,y
         lda $2820,y
         sta $26e0,y
         
         lda $28c0,y
         sta $2780,y
         lda $2960,y
         sta $2820,y
         
         lda $2a00,y
         sta $28c0,y
         lda $2aa0,y
         sta $2960,y
         
         lda $2b40,y
         sta $2a00,y
         lda $2be0,y
         sta $2aa0,y
         
         lda $2c80,y
         sta $2b40,y
         lda $2d20,y
         sta $2be0,y
         
         lda $2dc0,y
         sta $2c80,y
         lda $2e60,y
         sta $2d20,y
         
         lda $2f00,y
         sta $2dc0,y
         lda $2fa0,y
         sta $2e60,y
         
         lda $3040,y
         sta $2f00,y
         lda $30e0,y
         sta $2fa0,y
         
         lda $3180,y
         sta $3040,y
         lda $3220,y
         sta $30e0,y
         
         lda $32c0,y
         sta $3180,y
         lda $3360,y
         sta $3220,y
         
         lda $3400,y
         sta $32c0,y
         lda $34a0,y
         sta $3360,y
                   
         lda $3540,y
         sta $3400,y
         lda $35e0,y
         sta $34a0,y
         
         lda $3680,y
         sta $3540,y
         lda $3720,y
         sta $35e0,y
         
         lda $37c0,y
         sta $3680,y
         lda $3860,y
         sta $3720,y
         
         lda $3900,y
         sta $37c0,y
         lda $39a0,y
         sta $3860,y
                    
         lda $3a40,y
         sta $3900,y
         lda $3ae0,y
         sta $39a0,y
         
         lda $3b80,y
         sta $3a40,y
         lda $3c20,y
         sta $3ae0,y
         
         lda $3cc0,y
         sta $3b80,y
         lda $3d60,y
         sta $3c20,y
         
         lda $3e00,y
         sta $3cc0,y
         lda $3ea0,y
         sta $3d60,y
         
         lda #$00
         sta $3e00,y
         sta $3ea0,y  ;smazani posledniho radku

         iny
         cpy #$a0
         beq end_scroll
         jmp move_all
end_scroll cli
         rts


;---------------------------------------------------------
;Smaze graf.obrazovku

clrscr   sei
         ldy #0
         tya
cele1    sta $2000,y
         sta $20a0,y
         sta $2140,y
         sta $21e0,y
         sta $2280,y
         sta $2320,y
         sta $23c0,y
         sta $2460,y

         sta $2500,y
         sta $25a0,y
         sta $2640,y
         sta $26e0,y
         sta $2780,y
         sta $2820,y
         sta $28c0,y
         sta $2960,y

         sta $2a00,y
         sta $2aa0,y
         sta $2b40,y
         sta $2be0,y
         sta $2c80,y
         sta $2d20,y
         sta $2dc0,y
         sta $2e60,y

         sta $2f00,y
         sta $2fa0,y
         sta $3040,y
         sta $30e0,y
         sta $3180,y
         sta $3220,y
         sta $32c0,y
         sta $3360,y

         sta $3400,y
         sta $34a0,y
         sta $3540,y
         sta $35e0,y
         sta $3680,y
         sta $3720,y
         sta $37c0,y
         sta $3860,y

         sta $3900,y
         sta $39a0,y
         sta $3a40,y
         sta $3ae0,y
         sta $3b80,y
         sta $3c20,y
         sta $3cc0,y
         sta $3d60,y

         sta $3e00,y
         sta $3ea0,y

         iny
         cpy #$a0
         beq uzne1
         jmp cele1
uzne1    lda #$00
         sta $d6  ;crsr home
         sta $d3
         cli
         rts




;---------------------------------------
; kodovaci tabulka pro CESTINU
;----------------------- s cestinou ----
screen   .byte 0,0,0,0
         .byte 0,0,0,0
         .byte 0,0,0,0
         .byte 0,0,0,0
                             ;16
         .byte 0,0,0,0
         .byte 8,0,0,0
         .byte 0,0,0,0
         .byte 0,0,0,0
                             ;32
         .byte 32,33,34,35
         .byte 36,37,38,39
         .byte 40,41,42,43
         .byte 44,45,46,47
                             ;48
         .byte 48,49,50,51
         .byte 52,53,54,55
         .byte 56,57,58,59
         .byte 60,61,62,63
                             ;64
         .byte 31,65,66,67
         .byte 68,69,70,71
         .byte 72,73,74,75
         .byte 76,77,78,79
                             ;80
         .byte 80,81,82,83
         .byte 84,85,86,87
         .byte 88,89,90,27
         .byte 28,29,30,100
                             ;96
         .byte 31,1,2,3
         .byte 4,5,6,7
         .byte 8,9,10,11
         .byte 12,13,14,15
                             ;112
         .byte 16,17,18,19
         .byte 20,21,22,23
         .byte 24,25,26,27
         .byte 92,93,94,95
                             ;128
         .byte 113,91,94,116
         .byte 91,117,119,112
         .byte 96,97,91,99
         .byte 91,91,91,93
                             ;144
         .byte 95,108,109,91
         .byte 91,103,106,105  ;8
         .byte 100,91,91,111
         .byte 91,101,115,118
                             ;160
         .byte 92,98,102,104
         .byte 120,121,107,91
         .byte 110,114,91,91
         .byte 91,91,91,91
                             ;176
         .byte 176,177,178,179
         .byte 180,181,182,183
         .byte 184,185,186,187
         .byte 188,189,190,191
                             ;192

         .byte 192,65,66,67
         .byte 68,69,70,71
         .byte 72,73,74,75
         .byte 76,77,78,79
                             ;208
         .byte 80,81,82,83
         .byte 84,85,86,87
         .byte 88,89,90,219
         .byte 220,221,222,223
                             ;224
         .byte 224,225,226,227
         .byte 228,229,230,231
         .byte 232,233,234,235
         .byte 236,237,238,239
                             ;240
         .byte 240,241,242,243
         .byte 244,245,246,247
         .byte 248,249,250,251
         .byte 252,253,254,255



input_txt .text $0d,"VIEW FILE:",0

endoftext .text $0d,"==========END OF TEXT, PRESS <- FOR EXIT========",0


filename .byte 0              ;nazev 256 bajtu volno
EndPrg = filename + 256
         
         * =256*[1+EndPrg/256] ; zacatek znakovky od cele adresy
         
         
charset  .binary "charset.bin"
         
         .if *>=$2000
         .error "Charset in Graphics RAM"
         .endif
